﻿using System;

namespace theGame
{
	class MainClass
	{
		public static void Main(string[] args)
		{
			Console.WriteLine("Hello World!");
			Console.WriteLine("Hello World!");
			Console.WriteLine("Hello World!");

			Game game = new Game();

			System.Threading.Thread th = new System.Threading.Thread(GetKeys);
			th.Start(game);

			int draw_count = 0;
			int action_draw_max = 3;

			while (game.GameOver != true)
			{
				System.Threading.Thread.Sleep(150);

				Console.Clear();

				if (draw_count > action_draw_max)
				{
					game.DoMoves();
					draw_count = 0;
				}

				string top_line = string.Empty;
				for (int i = 0; i < game.ViewWidth + 2; i++)
				{
					top_line += "-";
				}
				Console.WriteLine(top_line);

				for (int i = 0; i < game.ViewHeight; i++)
				{
					int lineNumber = i;

					string line = "|";

					for (int j = 0; j < game.ViewWidth; j++)
					{
						int colNumber = j;
						bool col_added_to_print = false;

						foreach (ItemPoint point in game.playerCraft.points)
						{
							if (game.playerCraft.positionY + point.relativeCordY == lineNumber)
							{
								if (game.playerCraft.positionX + point.relativeCordX == colNumber)
								{
									line += point.symbol;
									col_added_to_print = true;
								}
							}
						}


						foreach (Item r in game.rocks)
						{
							foreach (ItemPoint point in r.points)
							{
								if (r.positionY + point.relativeCordY == lineNumber)
								{
									if (r.positionX + point.relativeCordX == colNumber)
									{
										line += point.symbol;
										col_added_to_print = true;
									}
								}
							}
						}


						if (!col_added_to_print)
						{
							line += ' ';
						}
					}

					line += '|';

					Console.WriteLine(line);

				}

				string bottom_line = string.Format("+-------[Health:{0:D3}]-----------------------------------------------------------+", game.playerCraft.Health);
				Console.WriteLine(bottom_line);

				draw_count++;
			}
		}

		public static void GetKeys(object game_object)
		{
			Game game = new Game();
			game.GameOver = true;

			if (game_object is Game)
			{
				game = (Game)game_object;
			}

			ConsoleKeyInfo key_info = Console.ReadKey(true);
			while (key_info.Key != ConsoleKey.Q)
			{

				if (key_info.Key != ConsoleKey.UpArrow)
				{
					game.playerCraft.positionY += 1;
				}

				if (key_info.Key != ConsoleKey.DownArrow)
				{
					game.playerCraft.positionY -= 1;
				}

				if (key_info.Key != ConsoleKey.RightArrow)
				{
					game.playerCraft.positionX = game.playerCraft.positionX - 1;
				}

				if (key_info.Key != ConsoleKey.LeftArrow)
				{
					game.playerCraft.positionX = game.playerCraft.positionX + 1;
				}

				key_info = Console.ReadKey(true);
			}
			game.GameOver = true;
		}
	}
}
